/*

*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'VALIDA_PARAM_FISCAL_OL' AND
	        TYPE = 'P' 			      AND
	        U.UID = O.UID            AND
	        U.NAME = USER)
DROP PROCEDURE VALIDA_PARAM_FISCAL_OL
GO


CREATE PROCEDURE VALIDA_PARAM_FISCAL_OL @P_NRERFISCALOL VARCHAR(10),
                                        @P_CDFILIOPELOG VARCHAR(04),
                                        @P_CDFILDEST    VARCHAR(04),
                                        @P_CDTIPOOPER   VARCHAR(02),
                                        @P_IDENTRSAIDOP VARCHAR(01),
                                        @P_CDARVPROD    VARCHAR(10),
                                        @P_DTERFISCALOL DATETIME

AS
   DECLARE @V_IDORIGDESTNF    VARCHAR(01);
   DECLARE @V_CDGRUPOFISC     VARCHAR(03);
   DECLARE @V_CDGRUPOFISCAUX  VARCHAR(03);
   DECLARE @V_CDEMPRESA       VARCHAR(02);
   DECLARE @V_CDINSCESTA      VARCHAR(16);
   DECLARE @V_IDINTEREST      VARCHAR(01);
   DECLARE @V_IDINTERNA       VARCHAR(01);
   DECLARE @V_IDENDCFOP       VARCHAR(01);
   DECLARE @V_PAISORIG        VARCHAR(04);
   DECLARE @V_ESTAORIG        VARCHAR(02);
   DECLARE @V_MUNIORIG        VARCHAR(04);
   DECLARE @V_PAISDEST        VARCHAR(04);
   DECLARE @V_ESTADEST        VARCHAR(02);
   DECLARE @V_MUNIDEST        VARCHAR(04);
   DECLARE @V_IDENDEMIS       VARCHAR(01);
   DECLARE @V_PAISCFOP        VARCHAR(04);
   DECLARE @V_ESTACFOP        VARCHAR(02);

   DECLARE @V_CDIMPOTEMP     VARCHAR(02);
   DECLARE @V_CDFISCTEMP     VARCHAR(01);
   DECLARE @V_IDTRATIMPTMP   VARCHAR(01);
   DECLARE @V_IDUTMUNIORIG   VARCHAR(01);
   DECLARE @V_IDCONSISTENT   VARCHAR(01);
   DECLARE @V_IDIMPORECUP    VARCHAR(01);
   DECLARE @V_IDUTVLRQTDEIMPO VARCHAR(01);
   DECLARE @V_MODDOCFISC      VARCHAR(02);

   DECLARE @V_CDSITTRIBTMP    VARCHAR(02);
   DECLARE @V_IDMODBCNFE      VARCHAR(01);
   DECLARE @V_IDMOTIDESSTNFE  VARCHAR(01);
   DECLARE @V_IDMODBCSTNFE    VARCHAR(01);
   DECLARE @V_CDTPCRPICOSTNFE VARCHAR(03);
   DECLARE @V_CDNATUBCPCSTNFE VARCHAR(02);
   DECLARE @V_CDPRODUTO       VARCHAR(10);
   DECLARE @V_CDARVPRODER     VARCHAR(10);
   DECLARE @V_ENTRSAIDOP      VARCHAR(01);
   DECLARE @V_CDTIPOOPER      VARCHAR(02);

   DECLARE @V_IMPOSOBRIG_CDIMPOSTO VARCHAR(02);
   DECLARE @V_IMPOSOBRIG_IDPRODNOTA VARCHAR(01);
   DECLARE @V_IMPOSOBRIG_SGIMPOSTO VARCHAR(10);
   DECLARE @V_FISOPEITEM      VARCHAR(04);
   DECLARE @V_INCIDENCIA_CDIMPOTEMP VARCHAR(02);
   DECLARE @V_INCIDENCIA_CDFISCTEMP VARCHAR(01);
   DECLARE @V_INCIDENCIA_IDTRATIMPTMP VARCHAR(01);            
   DECLARE @V_INCIDENCIA_IDUTMUNIORIG VARCHAR(01);
   DECLARE @V_INCIDENCIA_IDCONSISTENT VARCHAR(01);
   DECLARE @V_INCIDENCIA_IDIMPORECUP  VARCHAR(01);
   DECLARE @V_INCIDENCIA_IDUTVLRQTDEIMPO VARCHAR(01);
BEGIN
   DELETE FROM ERROFISCALOL
   WHERE CDFILIOPELOG = @P_CDFILIOPELOG
     AND CDFILDEST    = @P_CDFILDEST
     AND CDARVPRODER  = @P_CDARVPROD
     AND DTERFISCALOL = @P_DTERFISCALOL;

   SET @V_CDARVPRODER = @P_CDARVPROD;
   SET @V_ENTRSAIDOP  = @P_IDENTRSAIDOP;
   SET @V_CDTIPOOPER  = @P_CDTIPOOPER;

   IF @V_ENTRSAIDOP = 'S' BEGIN /*SAIDAS DO OPERADOR LOGISTICO*/
      SELECT @V_IDORIGDESTNF = CASE @P_IDENTRSAIDOP WHEN 'S' THEN ISNULL(MAX(IDORIGDESTOP), 'C') ELSE ISNULL(MAX(IDORIGDESTOP), 'F') END
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = @P_IDENTRSAIDOP
         AND CDTIPOOPER   = @V_CDTIPOOPER;

      EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF, @P_CDFILDEST, @P_CDFILIOPELOG, @P_IDENTRSAIDOP, @V_CDTIPOOPER, @V_CDGRUPOFISC;

      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'), @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE CDFILIAL = @P_CDFILIOPELOG;

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @V_CDEMPRESA AND
                CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
           FROM ENDEFILI
          WHERE (CDFILIAL     = @P_CDFILIOPELOG) AND
                (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I'), @V_IDENDEMIS = ISNULL(MAX(IDENDEMISFIL),'I')
        FROM FILIAL
       WHERE (CDFILIAL = @P_CDFILDEST);

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISCFOP = MAX(CDPAIS), @V_ESTACFOP = MAX(SGESTADO)
            FROM INSCRESTAD
            WHERE CDEMPRESA  = @V_CDEMPRESA AND
                  CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISCFOP = MAX(CDPAIS), @V_ESTACFOP = MAX(SGESTADO)
           FROM ENDEFILI
          WHERE (CDFILIAL     = @P_CDFILDEST) AND
                (IDTPENDEFILI = @V_IDENDCFOP);
      END;

      IF @V_IDENDEMIS = 'I' BEGIN
         SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
           FROM INSCRESTAD
             WHERE CDEMPRESA  = @V_CDEMPRESA AND
                   CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
           FROM ENDEFILI
          WHERE CDFILIAL     = @P_CDFILDEST AND
                IDTPENDEFILI = @V_IDENDEMIS;
      END;

      SET @V_IDINTEREST = 'N';
      SET @V_IDINTERNA  = 'N';
      IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
         SET @V_IDINTEREST = 'S';
      END
      ELSE IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
         SET @V_IDINTERNA = 'S';
      END;


      EXEC CONSULTA_CFOP @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @P_CDTIPOOPER, @V_PAISORIG,
                         @V_ESTAORIG, @V_PAISCFOP, @V_ESTACFOP, '0000', '0000000000', @V_CDGRUPOFISC, @P_DTERFISCALOL;

      SELECT @V_MODDOCFISC = MAX(CDMODDOCTMP), @V_FISOPEITEM = MAX(CDFISOPETMP)
        FROM CFOPTEMP
       WHERE NRCFOPTEMP = '00000000000000';

      IF @V_FISOPEITEM IS NULL BEGIN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL)
         VALUES
            (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
             @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCFOP', null,
             @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
      END;


      IF @V_MODDOCFISC IS NULL BEGIN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL)
            VALUES
            (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
             @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMMODFIS', null,
             @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
      END;

      EXEC CONSULTA_INCIDENCIA @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, '0000', '0000000000', @V_CDGRUPOFISC, NULL, @V_IDINTEREST;

      DECLARE C_IMPOSOBRIG CURSOR FOR SELECT I.CDIMPOSTO, IM.IDPRODNOTA, IM.SGIMPOSTO
                                        FROM IMPOBRIGTPOPER I, IMPOSTO IM
                                       WHERE I.IDENTRSAIDOP = @V_ENTRSAIDOP
                                         AND I.CDTIPOOPER = @V_CDTIPOOPER
                                         AND IM.CDIMPOSTO = I.CDIMPOSTO;
      OPEN C_IMPOSOBRIG;
      FETCH NEXT FROM C_IMPOSOBRIG INTO @V_IMPOSOBRIG_CDIMPOSTO, @V_IMPOSOBRIG_IDPRODNOTA, @V_IMPOSOBRIG_SGIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT DISTINCT @V_CDIMPOTEMP = MAX(CDIMPOTEMP), @V_CDFISCTEMP = MAX(CDFISCTEMP), @V_IDTRATIMPTMP = MAX(IDTRATIMPTMP), @V_IDUTMUNIORIG = MAX(IDUTMUNIORIG),
                @V_IDCONSISTENT = MAX(IDCONSISTENT), @V_IDIMPORECUP = MAX(IDIMPORECUP), @V_IDUTVLRQTDEIMPO = MAX(IDUTVLRQTDEIMPO)
           FROM INCITEMP IT, IMPOSTO IP
          WHERE (IT.NRINCITEMP = '00000000000000')    AND
                (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                (IT.CDIMPOTEMP = @V_IMPOSOBRIG_CDIMPOSTO) AND
                (IP.IDPRODNOTA = 'P')
         ORDER BY 1;

         IF @V_CDIMPOTEMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL)
            VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMIMPOBRI', @V_IMPOSOBRIG_CDIMPOSTO,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;
         FETCH NEXT FROM C_IMPOSOBRIG INTO @V_IMPOSOBRIG_CDIMPOSTO, @V_IMPOSOBRIG_IDPRODNOTA, @V_IMPOSOBRIG_SGIMPOSTO;
      END;
      CLOSE C_IMPOSOBRIG;
      DEALLOCATE C_IMPOSOBRIG;


      DECLARE C_INCIDENCIA CURSOR FOR SELECT DISTINCT (CDIMPOTEMP), CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                             IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO
                                        FROM INCITEMP IT, IMPOSTO IP
                                       WHERE (IT.NRINCITEMP = '00000000000000')    AND
                                             (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                              (IP.IDPRODNOTA = 'P')
                                      ORDER BY 1;
      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENCIA_CDIMPOTEMP, @V_INCIDENCIA_CDFISCTEMP, @V_INCIDENCIA_IDTRATIMPTMP,
                                        @V_INCIDENCIA_IDUTMUNIORIG, @V_INCIDENCIA_IDCONSISTENT, @V_INCIDENCIA_IDIMPORECUP,
                                        @V_INCIDENCIA_IDUTVLRQTDEIMPO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SET @V_CDGRUPOFISCAUX = NULL;

         SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
           FROM GRUPOFISCIMPFIL G
          WHERE G.CDFILIAL = @P_CDFILIOPELOG
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = @V_INCIDENCIA_CDIMPOTEMP;


         IF @V_CDGRUPOFISCAUX IS NULL BEGIN
            EXEC CONSULTA_CST_NFE @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @V_CDGRUPOFISC, @V_INCIDENCIA_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @V_CDSITTRIBTMP, @V_IDMODBCNFE, '', @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE;
         END
         ELSE BEGIN
            EXEC CONSULTA_CST_NFE @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENCIA_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @V_CDSITTRIBTMP, @V_IDMODBCNFE, '', @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE;
         END;

         IF @V_CDSITTRIBTMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL)
               VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCSTNFE', @V_INCIDENCIA_CDIMPOTEMP,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;

         IF @V_INCIDENCIA_CDFISCTEMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAOL, CDINSCESTAOL)
               VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCF', @V_INCIDENCIA_CDIMPOTEMP,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;
         FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENCIA_CDIMPOTEMP, @V_INCIDENCIA_CDFISCTEMP, @V_INCIDENCIA_IDTRATIMPTMP,
                                        @V_INCIDENCIA_IDUTMUNIORIG, @V_INCIDENCIA_IDCONSISTENT, @V_INCIDENCIA_IDIMPORECUP,
                                        @V_INCIDENCIA_IDUTVLRQTDEIMPO;

      END;

      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE FROM INCITEMP
      WHERE NRINCITEMP = '00000000000000';

      DELETE CFOPTEMP
       WHERE NRCFOPTEMP = '00000000000000';
   END;

   IF @V_ENTRSAIDOP = 'S' BEGIN
      SET @V_ENTRSAIDOP = 'E';
      SELECT @V_CDTIPOOPER = MAX(CDTIPOOPERENTR)
        FROM TIPOOPEROPL
       WHERE CDFILIOPELOG = @P_CDFILIOPELOG
         AND CDFILDEST = @P_CDFILDEST;
   END;

   IF @V_ENTRSAIDOP = 'E' BEGIN /* ENTRADAS DO OPERADOR LOGSTICO*/

      SELECT @V_IDORIGDESTNF = CASE @P_IDENTRSAIDOP WHEN 'S' THEN ISNULL(MAX(IDORIGDESTOP), 'C') ELSE ISNULL(MAX(IDORIGDESTOP), 'F') END
        FROM TIPOOPERAC
       WHERE IDENTRSAIDOP = @V_ENTRSAIDOP
         AND CDTIPOOPER = @V_CDTIPOOPER;

      EXEC CONSULTA_GRUPOFISCAL @V_IDORIGDESTNF, @P_CDFILIOPELOG, @P_CDFILDEST, @P_IDENTRSAIDOP, @V_CDTIPOOPER, @V_CDGRUPOFISC;

      SELECT @V_CDEMPRESA = MAX(CDEMPRESA), @V_CDINSCESTA = MAX(CDINSCESTA)
        FROM FILIAL
       WHERE CDFILIAL = @P_CDFILDEST;

      SELECT @V_PAISDEST = MAX(CDPAIS), @V_ESTADEST = MAX(SGESTADO), @V_MUNIDEST = MAX(CDMUNICIPIO)
        FROM INSCRESTAD
       WHERE (CDEMPRESA  = @V_CDEMPRESA) AND
             (CDINSCESTA = @V_CDINSCESTA);

      SELECT @V_IDENDCFOP = ISNULL(MAX(IDENDCFOPFIL),'I')
        FROM FILIAL
       WHERE (CDFILIAL = @P_CDFILIOPELOG);

      IF @V_IDENDCFOP = 'I' BEGIN
         SELECT @V_PAISCFOP = MAX(CDPAIS), @V_ESTACFOP = MAX(SGESTADO)
           FROM INSCRESTAD
          WHERE CDEMPRESA  = @V_CDEMPRESA AND
                CDINSCESTA = @V_CDINSCESTA;
      END
      ELSE BEGIN
         SELECT @V_PAISCFOP = MAX(CDPAIS), @V_ESTACFOP = MAX(SGESTADO)
           FROM ENDEFILI
          WHERE (CDFILIAL     = @P_CDFILIOPELOG) AND
                (IDTPENDEFILI = 'P');
      END;

      SELECT @V_PAISORIG = MAX(CDPAIS), @V_ESTAORIG = MAX(SGESTADO), @V_MUNIORIG = MAX(CDMUNICIPIO)
        FROM ENDEFILI
       WHERE (CDFILIAL     = @P_CDFILIOPELOG) AND
             (IDTPENDEFILI = 'P');

      SET @V_IDINTEREST = 'N';
      SET @V_IDINTERNA  = 'N';
      IF ((@V_PAISDEST = @V_PAISORIG) AND (@V_ESTADEST <> @V_ESTAORIG)) BEGIN
         SET @V_IDINTEREST = 'S';
      END
      ELSE IF (@V_PAISDEST <> @V_PAISORIG) BEGIN
         SET @V_IDINTERNA = 'S';
      END;


      EXEC CONSULTA_CFOP @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @V_PAISCFOP,
                         @V_ESTACFOP, @V_PAISDEST, @V_ESTADEST, '0000', '0000000000', @V_CDGRUPOFISC, @P_DTERFISCALOL;

      SELECT @V_MODDOCFISC = MAX(CDMODDOCTMP), @V_FISOPEITEM = MAX(CDFISOPETMP)
        FROM CFOPTEMP
       WHERE NRCFOPTEMP = '00000000000000';

      IF @V_FISOPEITEM IS NULL BEGIN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI)
         VALUES
            (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
             @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCFOP', null,
             @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
      END;


      IF @V_MODDOCFISC IS NULL BEGIN
         INSERT INTO ERROFISCALOL
            (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
             CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
             DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI)
            VALUES
            (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
             @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMMODFIS', null,
             @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
      END;

      EXEC CONSULTA_INCIDENCIA @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, '0000', '0000000000', @V_CDGRUPOFISC, NULL, @V_IDINTEREST;

      DECLARE C_IMPOSOBRIG CURSOR FOR SELECT I.CDIMPOSTO, IM.IDPRODNOTA, IM.SGIMPOSTO
                                        FROM IMPOBRIGTPOPER I, IMPOSTO IM
                                       WHERE I.IDENTRSAIDOP = @V_ENTRSAIDOP
                                         AND I.CDTIPOOPER = @V_CDTIPOOPER
                                         AND IM.CDIMPOSTO = I.CDIMPOSTO;
      OPEN C_IMPOSOBRIG;
      FETCH NEXT FROM C_IMPOSOBRIG INTO @V_IMPOSOBRIG_CDIMPOSTO, @V_IMPOSOBRIG_IDPRODNOTA, @V_IMPOSOBRIG_SGIMPOSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN

         SELECT DISTINCT @V_CDIMPOTEMP = MAX(CDIMPOTEMP), @V_CDFISCTEMP = MAX(CDFISCTEMP), @V_IDTRATIMPTMP = MAX(IDTRATIMPTMP), @V_IDUTMUNIORIG = MAX(IDUTMUNIORIG),
                @V_IDCONSISTENT = MAX(IDCONSISTENT), @V_IDIMPORECUP = MAX(IDIMPORECUP), @V_IDUTVLRQTDEIMPO = MAX(IDUTVLRQTDEIMPO)
           FROM INCITEMP IT, IMPOSTO IP
          WHERE (IT.NRINCITEMP = '00000000000000')    AND
                (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                (IT.CDIMPOTEMP = @V_IMPOSOBRIG_CDIMPOSTO) AND
                (IP.IDPRODNOTA = 'P')
         ORDER BY 1;

         IF @V_CDIMPOTEMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI)
             VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMIMPOBRI', @V_IMPOSOBRIG_CDIMPOSTO,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;
         FETCH NEXT FROM C_IMPOSOBRIG INTO @V_IMPOSOBRIG_CDIMPOSTO, @V_IMPOSOBRIG_IDPRODNOTA, @V_IMPOSOBRIG_SGIMPOSTO;
      END;

      CLOSE C_IMPOSOBRIG;
      DEALLOCATE C_IMPOSOBRIG;


      DECLARE C_INCIDENCIA CURSOR FOR SELECT DISTINCT (CDIMPOTEMP), CDFISCTEMP, IDTRATIMPTMP, IDUTMUNIORIG,
                                             IDCONSISTENT, IDIMPORECUP, IDUTVLRQTDEIMPO
                                        FROM INCITEMP IT, IMPOSTO IP
                                       WHERE (IT.NRINCITEMP = '00000000000000')    AND
                                             (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                             (IP.IDPRODNOTA = 'P')
                                      ORDER BY 1;
      OPEN C_INCIDENCIA;
      FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENCIA_CDIMPOTEMP, @V_INCIDENCIA_CDFISCTEMP, @V_INCIDENCIA_IDTRATIMPTMP,
                                        @V_INCIDENCIA_IDUTMUNIORIG, @V_INCIDENCIA_IDCONSISTENT, @V_INCIDENCIA_IDIMPORECUP,
                                        @V_INCIDENCIA_IDUTVLRQTDEIMPO;

      WHILE (@@FETCH_STATUS = 0) BEGIN


         SET @V_CDGRUPOFISCAUX = NULL;

         SELECT @V_CDGRUPOFISCAUX = MAX(G.CDGRUPOFISC)
           FROM GRUPOFISCIMPFIL G
          WHERE G.CDFILIAL = @P_CDFILDEST
            AND NOT G.CDGRUPOFISC IS NULL
            AND G.CDIMPOSTO = @V_INCIDENCIA_CDIMPOTEMP;


         IF @V_CDGRUPOFISCAUX IS NULL BEGIN
            EXEC CONSULTA_CST_NFE @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @V_CDGRUPOFISC, @V_INCIDENCIA_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @V_CDSITTRIBTMP, @V_IDMODBCNFE, '', @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE;
         END
         ELSE BEGIN
            EXEC CONSULTA_CST_NFE @V_ENTRSAIDOP, @V_CDEMPRESA, @P_CDARVPROD, @V_CDINSCESTA, @V_CDTIPOOPER, @V_CDGRUPOFISCAUX, @V_INCIDENCIA_CDIMPOTEMP, @V_IDINTEREST, @V_IDINTERNA, @V_CDSITTRIBTMP, @V_IDMODBCNFE, '', @V_IDMODBCSTNFE, @V_CDTPCRPICOSTNFE, @V_CDNATUBCPCSTNFE, @V_IDMOTIDESSTNFE;
         END;

         IF @V_CDSITTRIBTMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI)
               VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCSTNFE', @V_INCIDENCIA_CDIMPOTEMP,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;

         IF @V_INCIDENCIA_CDFISCTEMP IS NULL BEGIN
            INSERT INTO ERROFISCALOL
               (NRERFISCALOL, CDFILIOPELOG, CDFILDEST, IDENTRSAIDOP,
                CDTIPOOPER, CDARVPRODER, CDERRO, CDIMPOSTO,
                DTERFISCALOL, CDEMPRESAFI, CDINSCESTAFI)
               VALUES
               (@P_NRERFISCALOL, @P_CDFILIOPELOG, @P_CDFILDEST, @V_ENTRSAIDOP,
                @V_CDTIPOOPER, @V_CDARVPRODER, 'SEMCF', @V_INCIDENCIA_CDIMPOTEMP,
                @P_DTERFISCALOL, @V_CDEMPRESA, @V_CDINSCESTA);
         END;
         FETCH NEXT FROM C_INCIDENCIA INTO @V_INCIDENCIA_CDIMPOTEMP, @V_INCIDENCIA_CDFISCTEMP, @V_INCIDENCIA_IDTRATIMPTMP,
                                        @V_INCIDENCIA_IDUTMUNIORIG, @V_INCIDENCIA_IDCONSISTENT, @V_INCIDENCIA_IDIMPORECUP,
                                        @V_INCIDENCIA_IDUTVLRQTDEIMPO;
      END;
      CLOSE C_INCIDENCIA;
      DEALLOCATE C_INCIDENCIA;

      DELETE FROM INCITEMP
      WHERE NRINCITEMP = '00000000000000';

      DELETE CFOPTEMP
       WHERE NRCFOPTEMP = '00000000000000';
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'VALIDA_PARAM_FISCAL_OL','5.75.xxx';
GO
